#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>

#include "pthread.h"

pid_t	proc_id;
char	cmd[128];

void
print_mem_usage(void)
{
	FILE		*fp = popen(cmd, "r");
	static char	 buf[64];
	
	if (!fp)
	{
		fprintf(stderr, "popen() failed!\n");
		return;
	}

	(void) fgets(buf, sizeof(buf), fp);
	fgets(buf, sizeof(buf), fp);
	printf(": %s", buf);
	
	fclose(fp);
}

void *
sub_func(void *tmp)
{
	int		ret;
	size_t	sz = 128;
	char	buf[sz];
	
	struct passwd	 old_pw;
	struct passwd	*new_pw;

	ret = getpwuid_r(proc_id, &old_pw, buf, sz, &new_pw);
	if (ret)
		fprintf(stderr, "getpwuid_r() failed! ret = %d\n", ret);
	
	pthread_exit(NULL);
}

int
main(void)
{
	int			loop_count = 50;
	int 		thread_count = 100;
	pthread_t	threads[thread_count];
	int			i, ret;

	proc_id = getpid();
	sprintf(cmd, "ps -p %d -o rss,size", proc_id);

	while (loop_count--)
	{
		for (i = 0; i < thread_count; i++)
		{
			ret = pthread_create(&threads[i], NULL, sub_func, NULL);
			if (ret)
				fprintf(stderr, "pthread_create() failed! i = %d, ret = %d\n", i, ret);
		}

		for (i = 0; i < thread_count; i++)
		{
			ret = pthread_join(threads[i], NULL);
			if (ret)
				fprintf(stderr, "pthread_join() failed! i = %d, ret = %d\n", i, ret);
		}

		print_mem_usage();
	}

	return 0;
}

